org.yaml.snakeyaml.reader

## Class UnicodeReader

- java.lang.Object
- - java.io.Reader
  - - org.yaml.snakeyaml.reader.UnicodeReader

All Implemented Interfaces:
  Closeable, AutoCloseable, Readable

    public class UnicodeReader
    extends Reader

Generic unicode textreader, which will use BOM mark to identify the encoding to be used. If BOM is not found then use a given default or system encoding.

### Field Summary

### Fields inherited from class java.io.Reader

`lock`

### Constructor Summary

Constructors
Constructor and Description
`UnicodeReader(InputStream in)`

### Method Summary

Methods
`void` `close()`
`String` `getEncoding()` Get stream encoding or NULL if stream is uninitialized.
`protected void` `init()` Read-ahead four bytes and check for BOM marks.
`int` `read(char[] cbuf, int off, int len)`

### Methods inherited from class java.io.Reader

`mark, markSupported, read, read, read, ready, reset, skip`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### UnicodeReader

    public UnicodeReader(InputStream in)

Parameters:
  `in` - InputStream to be read

### Method Detail

#### getEncoding

    public String getEncoding()

Get stream encoding or NULL if stream is uninitialized. Call init() or read() method to initialize it.

Returns:
  the name of the character encoding being used by this stream.

#### init

    protected void init()
                 throws IOException

Read-ahead four bytes and check for BOM marks. Extra bytes are unread back to the stream, only BOM bytes are skipped.

Throws:
  `IOException` - if InputStream cannot be created

#### close

    public void close()
               throws IOException

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in class `Reader`
Throws:
  `IOException`

#### read

    public int read(char[] cbuf,
           int off,
           int len)
             throws IOException

Specified by:
  `read` in class `Reader`
Throws:
  `IOException`